<?php

namespace jki\es\models;

use yii\behaviors\BlameableBehavior;
use yii\behaviors\TimestampBehavior;
use yii\db\Expression;
use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "es_event_store".
 *
 * @property int               $id
 * @property string|null       $event_id
 * @property string|null       $event
 * @property string|null       $model_class
 * @property int|null          $model_id
 * @property int|null          $model_version
 * @property array|string|null $payload
 * @property string|null       $created_at
 * @property int               $created_by
 */
class EventStore extends \yii\db\ActiveRecord
{
    /**
     * @inheritdocs
     * @return array<string|int, array<string, mixed>>
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'timestamp' => [
                    'class'              => TimestampBehavior::class,
                    'createdAtAttribute' => 'created_at',
                    'updatedAtAttribute' => false,
                    'value'              => new Expression('now()'),
                ],
                'blamable'  => [
                    'class'              => BlameableBehavior::class,
                    'createdByAttribute' => 'created_by',
                    'updatedByAttribute' => false,
                ],
            ]
        );
    }


    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'es_event_store';
    }

    /**
     * {@inheritdoc}
     * @return array< string|int, array< int|string, mixed> >
     */
    public function rules()
    {
        return [
            [['model_id', 'model_version'], 'default', 'value' => null],
            [['model_id', 'model_version'], 'integer'],
            [['payload', 'created_at', 'created_by'], 'safe'],
            [['event_id'], 'string', 'max' => 36],
            [['event', 'model_class'], 'string', 'max' => 255],
        ];
    }

    public function beforeSave($insert)
    {
        if (
            ArrayHelper::getValue(
                \Yii::$app->db->schema->getTableSchema('es_event_store') ?? [],
                'columns.payload.dbType',
                false
            ) == 'longtext'
        ) {
            // @codeCoverageIgnoreStart
            $this->payload = json_encode($this->payload) ?: '';
            // @codeCoverageIgnoreEnd
        }
        return parent::beforeSave($insert); // TODO: Change the autogenerated stub
    }

    /**
     * @inheritdocs
     * @return void
     */
    public function afterFind()
    {
        parent::afterFind();
        if (
            ArrayHelper::getValue(
                \Yii::$app->db->schema->getTableSchema('es_event_store') ?? [],
                'columns.payload.dbType',
                false
            ) == 'longtext'
        ) {
            // @codeCoverageIgnoreStart
            if (is_string($this->payload)) {
                $this->payload = json_decode($this->payload, true);
            }
            // @codeCoverageIgnoreEnd
        }
    }
}
